searchNodes=[{"doc":"A Kafka connector for Broadway. BroadwayKafka can subscribe as a consumer to one or more topics and process streams of records within the same consumer group. Communication is done through Kafka&#39;s Consumer API using the :brod client. Options :hosts - Required. A keyword list of host/port pairs to use for establishing the initial connection to Kafka, e.g. [localhost: 9092]. :group_id - Required. A unique string that identifies the consumer group the producer will belong to. :topics - Required. A list of topics or a keyword list of topic/partition that the producer will subscribe to. :receive_interval - Optional. The duration (in milliseconds) for which the producer waits before making a request for more messages. Default is 2000 (2 seconds). :offset_commit_on_ack - Optional. Tells Broadway to send or not an offset commit request after each acknowledgemnt. Default is true. Setting this value to false can increase performance since commit requests will respect the :offset_commit_interval_seconds option. However, setting long commit intervals might lead to a large number of duplicated records to be processed after a server restart or connection loss. If that&#39;s the case, make sure your logic is idempotent when consuming records to avoid inconsistencies. Also, bear in mind the the negative performance impact might be insignificant if you&#39;re using batchers since only one commit request will be performed per batch. :offset_reset_policy - Optional. Defines the offset to be used when there&#39;s no initial offset in Kafka or if the current offset has expired. Possible values are :earliest or :latest. Default is :latest. :group_config - Optional. A list of options used to configure the group coordinator. See the &quot;Group config options&quot; section below for a list of all available options. :fetch_config - Optional. A list of options used when fetching messages. See the &quot;Fetch config options&quot; section below for a list of all available options. :client_config - Optional. A list of options used when creating the client. See the &quot;Client config options&quot; section below for a list of all available options. Group config options The available options that will be passed to :brod&#39;s group coordinator. :offset_commit_interval_seconds - Optional. The time interval between two OffsetCommitRequest messages. Default is 5. :rejoin_delay_seconds - Optional. Delay in seconds before rejoining the group. Default is 1. :session_timeout_seconds - Optional. Time in seconds the group coordinator broker waits before considering a member &#39;down&#39; if no heartbeat or any kind of request is received. A group member may also consider the coordinator broker &#39;down&#39; if no heartbeat response is received in the past N seconds. Default is 10 seconds. Fetch config options The available options that will be internally passed to :brod.fetch/5. :min_bytes - Optional. The minimum amount of data to be fetched from the server. If not enough data is available the request will wait for that much data to accumulate before answering. Default is 1 byte. Setting this value greater than 1 can improve server throughput a bit at the cost of additional latency. :max_bytes - Optional. The maximum amount of data to be fetched at a time from a single partition. Default is 1048576 (1 MiB). Setting greater values can improve server throughput at the cost of more memory consumption. Client config options The available options that will be internally passed to :brod.start_client/3. :ssl - Optional. A list of options to use when connecting via SSL/TLS. See the tls_client_option documentation for more information. Default is no ssl options. Note: Currently, Broadway does not support all options provided by :brod. If you have a scenario where you need any extra option that is not listed above, please open an issue, so we can consider adding it. Example Broadway.start_link(MyBroadway, name: MyBroadway, producer: [ module: {BroadwayKafka.Producer, [ hosts: [localhost: 9092], group_id: &quot;group_1&quot;, topics: [&quot;test&quot;], ]}, concurrency: 10 ], processors: [ default: [ concurrency: 10 ] ] ) Concurrency and partitioning The concurrency model provided by Kafka is based on partitioning, i.e., the more partitions you have, the more concurrency you get. However, in order to take advantage of this model you need to set up the :concurrency options for your processors and batchers accordingly. Having less concurrency than topic/partitions assigned will result in individual processors handling more than one partition, decreasing the overall level of concurrency. Therefore, if you want to always be able to process messages at maximum concurrency (assuming you have enough resources to do it), you should increase the concurrency up front to make sure you have enough processors to handle the extra messages received from new partitions assigned. Note: Even if you don&#39;t plan to add more partitions to a Kafka topic, your pipeline can still receive more assignments than planned. For instance, if another consumer crashes, the server will reassign all its topic/partition to other available consumers, including any Broadway producer subscribed to the same topic. Handling failed messages broadway_kafka never stops the flow of the stream, i.e. it will always ack the messages even when they fail. Unlike queue-based connectors, where you can mark a single message as failed. In Kafka that&#39;s not possible due to its single offset per topic/partition ack strategy. If you want to reprocess failed messages, you need to roll your own strategy. A possible way to do that is to implement Broadway.handle_failed/2 and send failed messages to a separated stream or queue for later processing.","ref":"BroadwayKafka.Producer.html","title":"BroadwayKafka.Producer","type":"module"},{"doc":"","ref":"BroadwayKafka.Producer.html#brod_received_assignment/1","title":"BroadwayKafka.Producer.brod_received_assignment/1","type":"macro"},{"doc":"","ref":"BroadwayKafka.Producer.html#brod_received_assignment/2","title":"BroadwayKafka.Producer.brod_received_assignment/2","type":"macro"},{"doc":"","ref":"BroadwayKafka.Producer.html#kafka_message/1","title":"BroadwayKafka.Producer.kafka_message/1","type":"macro"},{"doc":"","ref":"BroadwayKafka.Producer.html#kafka_message/2","title":"BroadwayKafka.Producer.kafka_message/2","type":"macro"}]